//snippets, samples, and audioPlayers are different entities

//use the AudioPlayer for large files you don't want to load into memory - it will read directly from disk
//use snippets for files you want to load into memory - it probably doesn't make too much of a difference really, but if you are loading lots of files you will start to see problems if you use all snippets
//use samples for small sounds you want to trigger over and over - this is more important

import ddf.minim.*;

Minim minim;
AudioSnippet snip;
AudioSample[] samples = new AudioSample[4];
AudioPlayer alky;
boolean alkyPlaying = false;

void setup()
{
  size(512, 200);
  
  minim = new Minim(this);
  
  snip = minim.loadSnippet("beat.aif");
  
  samples[0] = minim.loadSample("eagleland.mp3");
  samples[1] = minim.loadSample("thirtyFeet.mp3");
  samples[2] = minim.loadSample("sixtySeconds.mp3");
  samples[3] = minim.loadSample("enginesStop.mp3");
  
  alky = minim.loadFile("alky.mp3");
  
  // play the file
  snip.play();
  //set the loop to the number of times you want to loop
  //-1 sets it to infinite
  snip.loop(-1);
}

void keyPressed()
{

  if ( key == 's' ) {
    int randomSample = int(random(4));
    samples[randomSample].trigger();
  } 
  else if ( key == 'q' ) {
    samples[0].trigger();
  } 
  else if ( key == 'w' ) {
    samples[1].trigger();
  } 
  else if ( key == 'e' ) {
    samples[2].trigger();
  } 
  else if ( key == 'r' ) {
    samples[3].trigger();
  }
  else if (key == 'a') {
    if (alkyPlaying) {
      alky.pause();
    } 
    else {
      alky.play();
    }
    alkyPlaying = !alkyPlaying;
  }
}

void draw()
{
  background(0);
  // there are no waveforms to draw
}

void stop()
{
  // always close Minim audio classes when you are done with them
  snip.close();
  for(int i = 0; i<4; i++){
   samples[i].close(); 
  }
  alky.close();
  // always stop Minim before exiting
  minim.stop();
  
  super.stop();
}
